summaryrefslogtreecommitdiff
path: root/linode-ddns.sh
diff options
context:
space:
mode:
authorDavid Vazgenovich Shakaryan <dvshakaryan@gmail.com>2022-12-09 05:14:07 -0800
committerDavid Vazgenovich Shakaryan <dvshakaryan@gmail.com>2022-12-09 05:14:07 -0800
commit3e2bb49efc35039d9510ea0f9d11b5446b53c923 (patch)
tree8c85616965dc85281d635fea21d43c2b66f4be70 /linode-ddns.sh
parent7d5817dfcd5f93e56f770353059ba845314f9646 (diff)
downloadhetzner-ddns-3e2bb49efc35039d9510ea0f9d11b5446b53c923.tar.gz
hetzner-ddns-3e2bb49efc35039d9510ea0f9d11b5446b53c923.tar.xz
automatically tokenise domain
Diffstat (limited to 'linode-ddns.sh')
-rwxr-xr-xlinode-ddns.sh31
1 files changed, 19 insertions, 12 deletions
diff --git a/linode-ddns.sh b/linode-ddns.sh
index d3a9923..cd0cd76 100755
--- a/linode-ddns.sh
+++ b/linode-ddns.sh
@@ -2,12 +2,12 @@
#
# Copyright 2022 David Vazgenovich Shakaryan
#
-# LINODE_TOKEN=<token> linode-ddns.sh <domain> <record name>
+# LINODE_TOKEN=<token> linode-ddns.sh <domain>
IP_RESOLVER='https://ifconfig.co'
+TARGET="${1}"
-DOMAIN="${1}"
-RECORD="${2}"
+shopt -s extglob
die() {
[[ -n "${@}" ]] && echo "${@}" >&2
@@ -22,18 +22,25 @@ lincurl() {
ip="$(curl -sf4 "${IP_RESOLVER}")" || die 'IP lookup failed'
-res="$(lincurl)" || die 'Domains lookup failed'
-domain_id="$(jq -er --arg domain "${DOMAIN}" \
- 'first(.data[] | select(.domain == $domain)) | .id' \
- <<< "${res}")" || die 'Domain not found'
+dom_re="${TARGET}"
+while [[ "${dom_re}" =~ ^([^\\]*)\.(.*)$ ]]; do
+ dom_re="(${BASH_REMATCH[1]}\\.)?${BASH_REMATCH[2]}"
+done
-res=$(lincurl "${domain_id}/records") || die 'Records lookup failed'
-record_id="$(jq -er --arg name "${RECORD}" \
+res="$(lincurl)" || die 'Domains lookup failed'
+IFS='|' read dom_id dom_name < <(jq -er --arg re "${dom_re}" \
+ '[.data[] | select(.domain | test("\\A" + $re + "\\z"))] |
+ if . == [] then (null | halt_error) else . end |
+ max_by(.domain | length) | [.id, .domain] | join("|")' \
+ <<< "${res}") || die 'Domain not found'
+rec_name="${TARGET%%?(.)${dom_name}}"
+
+res=$(lincurl "${dom_id}/records") || die 'Records lookup failed'
+rec_id="$(jq -er --arg name "${rec_name}" \
'first(.data[] | select(.type == "A" and .name == $name)) | .id' \
<<< "${res}")" || die 'Record not found'
-res="$(lincurl "${domain_id}/records/${record_id}")" \
- || die 'Record lookup failed'
+res="$(lincurl "${dom_id}/records/${rec_id}")" || die 'Record lookup failed'
old_ip="$(jq -r '.target' <<< "${res}")"
if [[ "${old_ip}" == "${ip}" ]]; then
@@ -41,7 +48,7 @@ if [[ "${old_ip}" == "${ip}" ]]; then
exit
fi
-res="$(lincurl "${domain_id}/records/${record_id}" \
+res="$(lincurl "${dom_id}/records/${rec_id}" \
-H 'Content-Type: application/json' \
-X PUT -d "{\"target\":\"${ip}\"}")" || die 'Record update failed'
new_ip="$(jq -r '.target' <<< "${res}")"